git-rebase--interactive.shon commit Merge branch 'ab/nuke-emacs-contrib' into next (13eb4e2)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its interactive mode.  "git rebase --interactive" makes it easy
   3# to fix up commits in the middle of a series and rearrange commits.
   4#
   5# Copyright (c) 2006 Johannes E. Schindelin
   6#
   7# The original idea comes from Eric W. Biederman, in
   8# https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
   9#
  10# The file containing rebase commands, comments, and empty lines.
  11# This file is created by "git rebase -i" then edited by the user.  As
  12# the lines are processed, they are removed from the front of this
  13# file and written to the tail of $done.
  14todo="$state_dir"/git-rebase-todo
  15
  16# The rebase command lines that have already been processed.  A line
  17# is moved here when it is first handled, before any associated user
  18# actions.
  19done="$state_dir"/done
  20
  21# The commit message that is planned to be used for any changes that
  22# need to be committed following a user interaction.
  23msg="$state_dir"/message
  24
  25# The file into which is accumulated the suggested commit message for
  26# squash/fixup commands.  When the first of a series of squash/fixups
  27# is seen, the file is created and the commit message from the
  28# previous commit and from the first squash/fixup commit are written
  29# to it.  The commit message for each subsequent squash/fixup commit
  30# is appended to the file as it is processed.
  31#
  32# The first line of the file is of the form
  33#     # This is a combination of $count commits.
  34# where $count is the number of commits whose messages have been
  35# written to the file so far (including the initial "pick" commit).
  36# Each time that a commit message is processed, this line is read and
  37# updated.  It is deleted just before the combined commit is made.
  38squash_msg="$state_dir"/message-squash
  39
  40# If the current series of squash/fixups has not yet included a squash
  41# command, then this file exists and holds the commit message of the
  42# original "pick" commit.  (If the series ends without a "squash"
  43# command, then this can be used as the commit message of the combined
  44# commit without opening the editor.)
  45fixup_msg="$state_dir"/message-fixup
  46
  47# $rewritten is the name of a directory containing files for each
  48# commit that is reachable by at least one merge base of $head and
  49# $upstream. They are not necessarily rewritten, but their children
  50# might be.  This ensures that commits on merged, but otherwise
  51# unrelated side branches are left alone. (Think "X" in the man page's
  52# example.)
  53rewritten="$state_dir"/rewritten
  54
  55dropped="$state_dir"/dropped
  56
  57end="$state_dir"/end
  58msgnum="$state_dir"/msgnum
  59
  60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  61# GIT_AUTHOR_DATE that will be used for the commit that is currently
  62# being rebased.
  63author_script="$state_dir"/author-script
  64
  65# When an "edit" rebase command is being processed, the SHA1 of the
  66# commit to be edited is recorded in this file.  When "git rebase
  67# --continue" is executed, if there are any staged changes then they
  68# will be amended to the HEAD commit, but only provided the HEAD
  69# commit is still the commit to be edited.  When any other rebase
  70# command is processed, this file is deleted.
  71amend="$state_dir"/amend
  72
  73# For the post-rewrite hook, we make a list of rewritten commits and
  74# their new sha1s.  The rewritten-pending list keeps the sha1s of
  75# commits that have been processed, but not committed yet,
  76# e.g. because they are waiting for a 'squash' command.
  77rewritten_list="$state_dir"/rewritten-list
  78rewritten_pending="$state_dir"/rewritten-pending
  79
  80# Work around Git for Windows' Bash whose "read" does not strip CRLF
  81# and leaves CR at the end instead.
  82cr=$(printf "\015")
  83
  84strategy_args=${strategy:+--strategy=$strategy}
  85test -n "$strategy_opts" &&
  86eval '
  87        for strategy_opt in '"$strategy_opts"'
  88        do
  89                strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
  90        done
  91'
  92
  93GIT_CHERRY_PICK_HELP="$resolvemsg"
  94export GIT_CHERRY_PICK_HELP
  95
  96comment_char=$(git config --get core.commentchar 2>/dev/null)
  97case "$comment_char" in
  98'' | auto)
  99        comment_char="#"
 100        ;;
 101?)
 102        ;;
 103*)
 104        comment_char=$(echo "$comment_char" | cut -c1)
 105        ;;
 106esac
 107
 108warn () {
 109        printf '%s\n' "$*" >&2
 110}
 111
 112# Output the commit message for the specified commit.
 113commit_message () {
 114        git cat-file commit "$1" | sed "1,/^$/d"
 115}
 116
 117orig_reflog_action="$GIT_REFLOG_ACTION"
 118
 119comment_for_reflog () {
 120        case "$orig_reflog_action" in
 121        ''|rebase*)
 122                GIT_REFLOG_ACTION="rebase -i ($1)"
 123                export GIT_REFLOG_ACTION
 124                ;;
 125        esac
 126}
 127
 128last_count=
 129mark_action_done () {
 130        sed -e 1q < "$todo" >> "$done"
 131        sed -e 1d < "$todo" >> "$todo".new
 132        mv -f "$todo".new "$todo"
 133        new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
 134        echo $new_count >"$msgnum"
 135        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
 136        echo $total >"$end"
 137        if test "$last_count" != "$new_count"
 138        then
 139                last_count=$new_count
 140                eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
 141                test -z "$verbose" || echo
 142        fi
 143}
 144
 145# Put the last action marked done at the beginning of the todo list
 146# again. If there has not been an action marked done yet, leave the list of
 147# items on the todo list unchanged.
 148reschedule_last_action () {
 149        tail -n 1 "$done" | cat - "$todo" >"$todo".new
 150        sed -e \$d <"$done" >"$done".new
 151        mv -f "$todo".new "$todo"
 152        mv -f "$done".new "$done"
 153}
 154
 155append_todo_help () {
 156        gettext "
 157Commands:
 158p, pick <commit> = use commit
 159r, reword <commit> = use commit, but edit the commit message
 160e, edit <commit> = use commit, but stop for amending
 161s, squash <commit> = use commit, but meld into previous commit
 162f, fixup <commit> = like \"squash\", but discard this commit's log message
 163x, exec <commit> = run command (the rest of the line) using shell
 164d, drop <commit> = remove commit
 165l, label <label> = label current HEAD with a name
 166t, reset <label> = reset HEAD to a label
 167m, merge [-C <commit> | -c <commit>] <label> [# <oneline>]
 168.       create a merge commit using the original merge commit's
 169.       message (or the oneline, if no original merge commit was
 170.       specified). Use -c <commit> to reword the commit message.
 171
 172These lines can be re-ordered; they are executed from top to bottom.
 173" | git stripspace --comment-lines >>"$todo"
 174
 175        if test $(get_missing_commit_check_level) = error
 176        then
 177                gettext "
 178Do not remove any line. Use 'drop' explicitly to remove a commit.
 179" | git stripspace --comment-lines >>"$todo"
 180        else
 181                gettext "
 182If you remove a line here THAT COMMIT WILL BE LOST.
 183" | git stripspace --comment-lines >>"$todo"
 184        fi
 185}
 186
 187make_patch () {
 188        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 189        case "$sha1_and_parents" in
 190        ?*' '?*' '?*)
 191                git diff --cc $sha1_and_parents
 192                ;;
 193        ?*' '?*)
 194                git diff-tree -p "$1^!"
 195                ;;
 196        *)
 197                echo "Root commit"
 198                ;;
 199        esac > "$state_dir"/patch
 200        test -f "$msg" ||
 201                commit_message "$1" > "$msg"
 202        test -f "$author_script" ||
 203                get_author_ident_from_commit "$1" > "$author_script"
 204}
 205
 206die_with_patch () {
 207        echo "$1" > "$state_dir"/stopped-sha
 208        git update-ref REBASE_HEAD "$1"
 209        make_patch "$1"
 210        die "$2"
 211}
 212
 213exit_with_patch () {
 214        echo "$1" > "$state_dir"/stopped-sha
 215        git update-ref REBASE_HEAD "$1"
 216        make_patch $1
 217        git rev-parse --verify HEAD > "$amend"
 218        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 219        warn "$(eval_gettext "\
 220You can amend the commit now, with
 221
 222        git commit --amend \$gpg_sign_opt_quoted
 223
 224Once you are satisfied with your changes, run
 225
 226        git rebase --continue")"
 227        warn
 228        exit $2
 229}
 230
 231die_abort () {
 232        apply_autostash
 233        rm -rf "$state_dir"
 234        die "$1"
 235}
 236
 237has_action () {
 238        test -n "$(git stripspace --strip-comments <"$1")"
 239}
 240
 241is_empty_commit() {
 242        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
 243                sha1=$1
 244                die "$(eval_gettext "\$sha1: not a commit that can be picked")"
 245        }
 246        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
 247                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 248        test "$tree" = "$ptree"
 249}
 250
 251is_merge_commit()
 252{
 253        git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
 254}
 255
 256# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 257# GIT_AUTHOR_DATE exported from the current environment.
 258do_with_author () {
 259        (
 260                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 261                "$@"
 262        )
 263}
 264
 265git_sequence_editor () {
 266        if test -z "$GIT_SEQUENCE_EDITOR"
 267        then
 268                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 269                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 270                then
 271                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 272                fi
 273        fi
 274
 275        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 276}
 277
 278pick_one () {
 279        ff=--ff
 280
 281        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 282        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 283        output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
 284
 285        if is_empty_commit "$sha1"
 286        then
 287                empty_args="--allow-empty"
 288        fi
 289
 290        test -d "$rewritten" &&
 291                pick_one_preserving_merges "$@" && return
 292        output eval git cherry-pick $allow_rerere_autoupdate $allow_empty_message \
 293                        ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 294                        "$strategy_args" $empty_args $ff "$@"
 295
 296        # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
 297        # previous task so this commit is not lost.
 298        ret=$?
 299        case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
 300        return $ret
 301}
 302
 303pick_one_preserving_merges () {
 304        fast_forward=t
 305        case "$1" in
 306        -n)
 307                fast_forward=f
 308                sha1=$2
 309                ;;
 310        *)
 311                sha1=$1
 312                ;;
 313        esac
 314        sha1=$(git rev-parse $sha1)
 315
 316        if test -f "$state_dir"/current-commit
 317        then
 318                if test "$fast_forward" = t
 319                then
 320                        while read current_commit
 321                        do
 322                                git rev-parse HEAD > "$rewritten"/$current_commit
 323                        done <"$state_dir"/current-commit
 324                        rm "$state_dir"/current-commit ||
 325                                die "$(gettext "Cannot write current commit's replacement sha1")"
 326                fi
 327        fi
 328
 329        echo $sha1 >> "$state_dir"/current-commit
 330
 331        # rewrite parents; if none were rewritten, we can fast-forward.
 332        new_parents=
 333        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 334        if test "$pend" = " "
 335        then
 336                pend=" root"
 337        fi
 338        while [ "$pend" != "" ]
 339        do
 340                p=$(expr "$pend" : ' \([^ ]*\)')
 341                pend="${pend# $p}"
 342
 343                if test -f "$rewritten"/$p
 344                then
 345                        new_p=$(cat "$rewritten"/$p)
 346
 347                        # If the todo reordered commits, and our parent is marked for
 348                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 349                        # drop it on top of the current HEAD
 350                        if test -z "$new_p"
 351                        then
 352                                new_p=$(git rev-parse HEAD)
 353                        fi
 354
 355                        test $p != $new_p && fast_forward=f
 356                        case "$new_parents" in
 357                        *$new_p*)
 358                                ;; # do nothing; that parent is already there
 359                        *)
 360                                new_parents="$new_parents $new_p"
 361                                ;;
 362                        esac
 363                else
 364                        if test -f "$dropped"/$p
 365                        then
 366                                fast_forward=f
 367                                replacement="$(cat "$dropped"/$p)"
 368                                test -z "$replacement" && replacement=root
 369                                pend=" $replacement$pend"
 370                        else
 371                                new_parents="$new_parents $p"
 372                        fi
 373                fi
 374        done
 375        case $fast_forward in
 376        t)
 377                output warn "$(eval_gettext "Fast-forward to \$sha1")"
 378                output git reset --hard $sha1 ||
 379                        die "$(eval_gettext "Cannot fast-forward to \$sha1")"
 380                ;;
 381        f)
 382                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 383
 384                if [ "$1" != "-n" ]
 385                then
 386                        # detach HEAD to current parent
 387                        output git checkout $first_parent 2> /dev/null ||
 388                                die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
 389                fi
 390
 391                case "$new_parents" in
 392                ' '*' '*)
 393                        test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
 394
 395                        # redo merge
 396                        author_script_content=$(get_author_ident_from_commit $sha1)
 397                        eval "$author_script_content"
 398                        msg_content="$(commit_message $sha1)"
 399                        # No point in merging the first parent, that's HEAD
 400                        new_parents=${new_parents# $first_parent}
 401                        merge_args="--no-log --no-ff"
 402                        if ! do_with_author output eval \
 403                                git merge ${gpg_sign_opt:+$(git rev-parse \
 404                                        --sq-quote "$gpg_sign_opt")} \
 405                                $allow_rerere_autoupdate "$merge_args" \
 406                                "$strategy_args" \
 407                                -m "$(git rev-parse --sq-quote "$msg_content")" \
 408                                "$new_parents"
 409                        then
 410                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 411                                die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
 412                        fi
 413                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 414                        ;;
 415                *)
 416                        output eval git cherry-pick $allow_rerere_autoupdate \
 417                                $allow_empty_message \
 418                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 419                                "$strategy_args" "$@" ||
 420                                die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
 421                        ;;
 422                esac
 423                ;;
 424        esac
 425}
 426
 427this_nth_commit_message () {
 428        n=$1
 429        eval_gettext "This is the commit message #\${n}:"
 430}
 431
 432skip_nth_commit_message () {
 433        n=$1
 434        eval_gettext "The commit message #\${n} will be skipped:"
 435}
 436
 437update_squash_messages () {
 438        if test -f "$squash_msg"; then
 439                mv "$squash_msg" "$squash_msg".bak || exit
 440                count=$(($(sed -n \
 441                        -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
 442                        -e "q" < "$squash_msg".bak)+1))
 443                {
 444                        printf '%s\n' "$comment_char $(eval_ngettext \
 445                                "This is a combination of \$count commit." \
 446                                "This is a combination of \$count commits." \
 447                                $count)"
 448                        sed -e 1d -e '2,/^./{
 449                                /^$/d
 450                        }' <"$squash_msg".bak
 451                } >"$squash_msg"
 452        else
 453                commit_message HEAD >"$fixup_msg" ||
 454                die "$(eval_gettext "Cannot write \$fixup_msg")"
 455                count=2
 456                {
 457                        printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
 458                        printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
 459                        echo
 460                        cat "$fixup_msg"
 461                } >"$squash_msg"
 462        fi
 463        case $1 in
 464        squash)
 465                rm -f "$fixup_msg"
 466                echo
 467                printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
 468                echo
 469                commit_message $2
 470                ;;
 471        fixup)
 472                echo
 473                printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
 474                echo
 475                # Change the space after the comment character to TAB:
 476                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
 477                ;;
 478        esac >>"$squash_msg"
 479}
 480
 481peek_next_command () {
 482        git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
 483}
 484
 485# A squash/fixup has failed.  Prepare the long version of the squash
 486# commit message, then die_with_patch.  This code path requires the
 487# user to edit the combined commit message for all commits that have
 488# been squashed/fixedup so far.  So also erase the old squash
 489# messages, effectively causing the combined commit to be used as the
 490# new basis for any further squash/fixups.  Args: sha1 rest
 491die_failed_squash() {
 492        sha1=$1
 493        rest=$2
 494        mv "$squash_msg" "$msg" || exit
 495        rm -f "$fixup_msg"
 496        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 497        warn
 498        warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
 499        die_with_patch $sha1 ""
 500}
 501
 502flush_rewritten_pending() {
 503        test -s "$rewritten_pending" || return
 504        newsha1="$(git rev-parse HEAD^0)"
 505        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 506        rm -f "$rewritten_pending"
 507}
 508
 509record_in_rewritten() {
 510        oldsha1="$(git rev-parse $1)"
 511        echo "$oldsha1" >> "$rewritten_pending"
 512
 513        case "$(peek_next_command)" in
 514        squash|s|fixup|f)
 515                ;;
 516        *)
 517                flush_rewritten_pending
 518                ;;
 519        esac
 520}
 521
 522do_pick () {
 523        sha1=$1
 524        rest=$2
 525        if test "$(git rev-parse HEAD)" = "$squash_onto"
 526        then
 527                # Set the correct commit message and author info on the
 528                # sentinel root before cherry-picking the original changes
 529                # without committing (-n).  Finally, update the sentinel again
 530                # to include these changes.  If the cherry-pick results in a
 531                # conflict, this means our behaviour is similar to a standard
 532                # failed cherry-pick during rebase, with a dirty index to
 533                # resolve before manually running git commit --amend then git
 534                # rebase --continue.
 535                git commit --allow-empty --allow-empty-message --amend \
 536                           --no-post-rewrite -n -q -C $sha1 &&
 537                        pick_one -n $sha1 &&
 538                        git commit --allow-empty --allow-empty-message \
 539                                   --amend --no-post-rewrite -n -q -C $sha1 \
 540                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 541                                   die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 542        else
 543                pick_one $sha1 ||
 544                        die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 545        fi
 546}
 547
 548do_next () {
 549        rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
 550        read -r command sha1 rest < "$todo"
 551        case "$command" in
 552        "$comment_char"*|''|noop|drop|d)
 553                mark_action_done
 554                ;;
 555        "$cr")
 556                # Work around CR left by "read" (e.g. with Git for Windows' Bash).
 557                mark_action_done
 558                ;;
 559        pick|p)
 560                comment_for_reflog pick
 561
 562                mark_action_done
 563                do_pick $sha1 "$rest"
 564                record_in_rewritten $sha1
 565                ;;
 566        reword|r)
 567                comment_for_reflog reword
 568
 569                mark_action_done
 570                do_pick $sha1 "$rest"
 571                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
 572                        $allow_empty_message || {
 573                        warn "$(eval_gettext "\
 574Could not amend commit after successfully picking \$sha1... \$rest
 575This is most likely due to an empty commit message, or the pre-commit hook
 576failed. If the pre-commit hook failed, you may need to resolve the issue before
 577you are able to reword the commit.")"
 578                        exit_with_patch $sha1 1
 579                }
 580                record_in_rewritten $sha1
 581                ;;
 582        edit|e)
 583                comment_for_reflog edit
 584
 585                mark_action_done
 586                do_pick $sha1 "$rest"
 587                sha1_abbrev=$(git rev-parse --short $sha1)
 588                warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
 589                exit_with_patch $sha1 0
 590                ;;
 591        squash|s|fixup|f)
 592                case "$command" in
 593                squash|s)
 594                        squash_style=squash
 595                        ;;
 596                fixup|f)
 597                        squash_style=fixup
 598                        ;;
 599                esac
 600                comment_for_reflog $squash_style
 601
 602                test -f "$done" && has_action "$done" ||
 603                        die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
 604
 605                mark_action_done
 606                update_squash_messages $squash_style $sha1
 607                author_script_content=$(get_author_ident_from_commit HEAD)
 608                echo "$author_script_content" > "$author_script"
 609                eval "$author_script_content"
 610                if ! pick_one -n $sha1
 611                then
 612                        git rev-parse --verify HEAD >"$amend"
 613                        die_failed_squash $sha1 "$rest"
 614                fi
 615                case "$(peek_next_command)" in
 616                squash|s|fixup|f)
 617                        # This is an intermediate commit; its message will only be
 618                        # used in case of trouble.  So use the long version:
 619                        do_with_author output git commit --amend --no-verify -F "$squash_msg" \
 620                                ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 621                                die_failed_squash $sha1 "$rest"
 622                        ;;
 623                *)
 624                        # This is the final command of this squash/fixup group
 625                        if test -f "$fixup_msg"
 626                        then
 627                                do_with_author git commit --amend --no-verify -F "$fixup_msg" \
 628                                        ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 629                                        die_failed_squash $sha1 "$rest"
 630                        else
 631                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 632                                rm -f "$GIT_DIR"/MERGE_MSG
 633                                do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
 634                                        ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 635                                        die_failed_squash $sha1 "$rest"
 636                        fi
 637                        rm -f "$squash_msg" "$fixup_msg"
 638                        ;;
 639                esac
 640                record_in_rewritten $sha1
 641                ;;
 642        x|"exec")
 643                read -r command rest < "$todo"
 644                mark_action_done
 645                eval_gettextln "Executing: \$rest"
 646                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
 647                status=$?
 648                # Run in subshell because require_clean_work_tree can die.
 649                dirty=f
 650                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 651                if test "$status" -ne 0
 652                then
 653                        warn "$(eval_gettext "Execution failed: \$rest")"
 654                        test "$dirty" = f ||
 655                                warn "$(gettext "and made changes to the index and/or the working tree")"
 656
 657                        warn "$(gettext "\
 658You can fix the problem, and then run
 659
 660        git rebase --continue")"
 661                        warn
 662                        if test $status -eq 127         # command not found
 663                        then
 664                                status=1
 665                        fi
 666                        exit "$status"
 667                elif test "$dirty" = t
 668                then
 669                        # TRANSLATORS: after these lines is a command to be issued by the user
 670                        warn "$(eval_gettext "\
 671Execution succeeded: \$rest
 672but left changes to the index and/or the working tree
 673Commit or stash your changes, and then run
 674
 675        git rebase --continue")"
 676                        warn
 677                        exit 1
 678                fi
 679                ;;
 680        *)
 681                warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
 682                fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
 683                if git rev-parse --verify -q "$sha1" >/dev/null
 684                then
 685                        die_with_patch $sha1 "$fixtodo"
 686                else
 687                        die "$fixtodo"
 688                fi
 689                ;;
 690        esac
 691        test -s "$todo" && return
 692
 693        comment_for_reflog finish &&
 694        newhead=$(git rev-parse HEAD) &&
 695        case $head_name in
 696        refs/*)
 697                message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
 698                git update-ref -m "$message" $head_name $newhead $orig_head &&
 699                git symbolic-ref \
 700                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 701                  HEAD $head_name
 702                ;;
 703        esac && {
 704                test ! -f "$state_dir"/verbose ||
 705                        git diff-tree --stat $orig_head..HEAD
 706        } &&
 707        {
 708                test -s "$rewritten_list" &&
 709                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 710                true # we don't care if this copying failed
 711        } &&
 712        hook="$(git rev-parse --git-path hooks/post-rewrite)"
 713        if test -x "$hook" && test -s "$rewritten_list"; then
 714                "$hook" rebase < "$rewritten_list"
 715                true # we don't care if this hook failed
 716        fi &&
 717                warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
 718
 719        return 1 # not failure; just to break the do_rest loop
 720}
 721
 722# can only return 0, when the infinite loop breaks
 723do_rest () {
 724        while :
 725        do
 726                do_next || break
 727        done
 728}
 729
 730expand_todo_ids() {
 731        git rebase--helper --expand-ids
 732}
 733
 734collapse_todo_ids() {
 735        git rebase--helper --shorten-ids
 736}
 737
 738# Switch to the branch in $into and notify it in the reflog
 739checkout_onto () {
 740        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
 741        output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
 742        git update-ref ORIG_HEAD $orig_head
 743}
 744
 745get_missing_commit_check_level () {
 746        check_level=$(git config --get rebase.missingCommitsCheck)
 747        check_level=${check_level:-ignore}
 748        # Don't be case sensitive
 749        printf '%s' "$check_level" | tr 'A-Z' 'a-z'
 750}
 751
 752# The whole contents of this file is run by dot-sourcing it from
 753# inside a shell function.  It used to be that "return"s we see
 754# below were not inside any function, and expected to return
 755# to the function that dot-sourced us.
 756#
 757# However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
 758# construct and continue to run the statements that follow such a "return".
 759# As a work-around, we introduce an extra layer of a function
 760# here, and immediately call it after defining it.
 761git_rebase__interactive () {
 762
 763case "$action" in
 764continue)
 765        if test ! -d "$rewritten"
 766        then
 767                exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
 768                        --continue
 769        fi
 770        # do we have anything to commit?
 771        if git diff-index --cached --quiet HEAD --
 772        then
 773                # Nothing to commit -- skip this commit
 774
 775                test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
 776                rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
 777                die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
 778        else
 779                if ! test -f "$author_script"
 780                then
 781                        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 782                        die "$(eval_gettext "\
 783You have staged changes in your working tree.
 784If these changes are meant to be
 785squashed into the previous commit, run:
 786
 787  git commit --amend \$gpg_sign_opt_quoted
 788
 789If they are meant to go into a new commit, run:
 790
 791  git commit \$gpg_sign_opt_quoted
 792
 793In both cases, once you're done, continue with:
 794
 795  git rebase --continue
 796")"
 797                fi
 798                . "$author_script" ||
 799                        die "$(gettext "Error trying to find the author identity to amend commit")"
 800                if test -f "$amend"
 801                then
 802                        current_head=$(git rev-parse --verify HEAD)
 803                        test "$current_head" = $(cat "$amend") ||
 804                        die "$(gettext "\
 805You have uncommitted changes in your working tree. Please commit them
 806first and then run 'git rebase --continue' again.")"
 807                        do_with_author git commit --amend --no-verify -F "$msg" -e \
 808                                ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 809                                die "$(gettext "Could not commit staged changes.")"
 810                else
 811                        do_with_author git commit --no-verify -F "$msg" -e \
 812                                ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 813                                die "$(gettext "Could not commit staged changes.")"
 814                fi
 815        fi
 816
 817        if test -r "$state_dir"/stopped-sha
 818        then
 819                record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
 820        fi
 821
 822        require_clean_work_tree "rebase"
 823        do_rest
 824        return 0
 825        ;;
 826skip)
 827        git rerere clear
 828
 829        if test ! -d "$rewritten"
 830        then
 831                exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
 832                        --continue
 833        fi
 834        do_rest
 835        return 0
 836        ;;
 837edit-todo)
 838        git stripspace --strip-comments <"$todo" >"$todo".new
 839        mv -f "$todo".new "$todo"
 840        collapse_todo_ids
 841        append_todo_help
 842        gettext "
 843You are editing the todo file of an ongoing interactive rebase.
 844To continue rebase after editing, run:
 845    git rebase --continue
 846
 847" | git stripspace --comment-lines >>"$todo"
 848
 849        git_sequence_editor "$todo" ||
 850                die "$(gettext "Could not execute editor")"
 851        expand_todo_ids
 852
 853        exit
 854        ;;
 855show-current-patch)
 856        exec git show REBASE_HEAD --
 857        ;;
 858esac
 859
 860comment_for_reflog start
 861
 862if test ! -z "$switch_to"
 863then
 864        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
 865        output git checkout "$switch_to" -- ||
 866                die "$(eval_gettext "Could not checkout \$switch_to")"
 867
 868        comment_for_reflog start
 869fi
 870
 871orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
 872mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
 873rm -f "$(git rev-parse --git-path REBASE_HEAD)"
 874
 875: > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
 876write_basic_state
 877if test t = "$preserve_merges"
 878then
 879        if test -z "$rebase_root"
 880        then
 881                mkdir "$rewritten" &&
 882                for c in $(git merge-base --all $orig_head $upstream)
 883                do
 884                        echo $onto > "$rewritten"/$c ||
 885                                die "$(gettext "Could not init rewritten commits")"
 886                done
 887        else
 888                mkdir "$rewritten" &&
 889                echo $onto > "$rewritten"/root ||
 890                        die "$(gettext "Could not init rewritten commits")"
 891        fi
 892        # No cherry-pick because our first pass is to determine
 893        # parents to rewrite and skipping dropped commits would
 894        # prematurely end our probe
 895        merges_option=
 896else
 897        merges_option="--no-merges --cherry-pick"
 898fi
 899
 900shorthead=$(git rev-parse --short $orig_head)
 901shortonto=$(git rev-parse --short $onto)
 902if test -z "$rebase_root"
 903        # this is now equivalent to ! -z "$upstream"
 904then
 905        shortupstream=$(git rev-parse --short $upstream)
 906        revisions=$upstream...$orig_head
 907        shortrevisions=$shortupstream..$shorthead
 908else
 909        revisions=$onto...$orig_head
 910        shortrevisions=$shorthead
 911fi
 912if test t != "$preserve_merges"
 913then
 914        git rebase--helper --make-script ${keep_empty:+--keep-empty} \
 915                ${recreate_merges:+--recreate-merges} \
 916                ${rebase_cousins:+--rebase-cousins} \
 917                $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
 918        die "$(gettext "Could not generate todo list")"
 919else
 920        format=$(git config --get rebase.instructionFormat)
 921        # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
 922        git rev-list $merges_option --format="%m%H ${format:-%s}" \
 923                --reverse --left-right --topo-order \
 924                $revisions ${restrict_revision+^$restrict_revision} | \
 925                sed -n "s/^>//p" |
 926        while read -r sha1 rest
 927        do
 928
 929                if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
 930                then
 931                        comment_out="$comment_char "
 932                else
 933                        comment_out=
 934                fi
 935
 936                if test -z "$rebase_root"
 937                then
 938                        preserve=t
 939                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
 940                        do
 941                                if test -f "$rewritten"/$p
 942                                then
 943                                        preserve=f
 944                                fi
 945                        done
 946                else
 947                        preserve=f
 948                fi
 949                if test f = "$preserve"
 950                then
 951                        touch "$rewritten"/$sha1
 952                        printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
 953                fi
 954        done
 955fi
 956
 957# Watch for commits that been dropped by --cherry-pick
 958if test t = "$preserve_merges"
 959then
 960        mkdir "$dropped"
 961        # Save all non-cherry-picked changes
 962        git rev-list $revisions --left-right --cherry-pick | \
 963                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
 964        # Now all commits and note which ones are missing in
 965        # not-cherry-picks and hence being dropped
 966        git rev-list $revisions |
 967        while read rev
 968        do
 969                if test -f "$rewritten"/$rev &&
 970                   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
 971                then
 972                        # Use -f2 because if rev-list is telling us this commit is
 973                        # not worthwhile, we don't want to track its multiple heads,
 974                        # just the history of its first-parent for others that will
 975                        # be rebasing on top of it
 976                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
 977                        sha1=$(git rev-list -1 $rev)
 978                        sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
 979                        rm "$rewritten"/$rev
 980                fi
 981        done
 982fi
 983
 984test -s "$todo" || echo noop >> "$todo"
 985test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
 986test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
 987
 988todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
 989todocount=${todocount##* }
 990
 991cat >>"$todo" <<EOF
 992
 993$comment_char $(eval_ngettext \
 994        "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
 995        "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
 996        "$todocount")
 997EOF
 998append_todo_help
 999gettext "
1000However, if you remove everything, the rebase will be aborted.
1001
1002" | git stripspace --comment-lines >>"$todo"
1003
1004if test -z "$keep_empty"
1005then
1006        printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
1007fi
1008
1009
1010has_action "$todo" ||
1011        return 2
1012
1013cp "$todo" "$todo".backup
1014collapse_todo_ids
1015git_sequence_editor "$todo" ||
1016        die_abort "$(gettext "Could not execute editor")"
1017
1018has_action "$todo" ||
1019        return 2
1020
1021git rebase--helper --check-todo-list || {
1022        ret=$?
1023        checkout_onto
1024        exit $ret
1025}
1026
1027expand_todo_ids
1028
1029test -d "$rewritten" || test -n "$force_rebase" ||
1030onto="$(git rebase--helper --skip-unnecessary-picks)" ||
1031die "Could not skip unnecessary pick commands"
1032
1033checkout_onto
1034if test -z "$rebase_root" && test ! -d "$rewritten"
1035then
1036        require_clean_work_tree "rebase"
1037        exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
1038                --continue
1039fi
1040do_rest
1041
1042}
1043# ... and then we call the whole thing.
1044git_rebase__interactive